
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Stock_reception_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_reception_items = await db.stock_reception_items.create(
            {
                id: data.id || undefined,
        
        quantity_received: data.quantity_received
        ||
        null
            ,
            
        unit_cost_ht: data.unit_cost_ht
        ||
        null
            ,
            
        expiry_date: data.expiry_date
        ||
        null
            ,
            
        batch_code: data.batch_code
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await stock_reception_items.setStock_reception( data.stock_reception || null, {
            transaction,
        });
        
        await stock_reception_items.setProduct( data.product || null, {
            transaction,
        });
        
        await stock_reception_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return stock_reception_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const stock_reception_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quantity_received: item.quantity_received
            ||
            null
            ,
            
                unit_cost_ht: item.unit_cost_ht
            ||
            null
            ,
            
                expiry_date: item.expiry_date
            ||
            null
            ,
            
                batch_code: item.batch_code
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const stock_reception_items = await db.stock_reception_items.bulkCreate(stock_reception_itemsData, { transaction });

        // For each item created, replace relation files
        

        return stock_reception_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const stock_reception_items = await db.stock_reception_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quantity_received !== undefined) updatePayload.quantity_received = data.quantity_received;
        
        
        if (data.unit_cost_ht !== undefined) updatePayload.unit_cost_ht = data.unit_cost_ht;
        
        
        if (data.expiry_date !== undefined) updatePayload.expiry_date = data.expiry_date;
        
        
        if (data.batch_code !== undefined) updatePayload.batch_code = data.batch_code;
        
        
        updatePayload.updatedById = currentUser.id;

        await stock_reception_items.update(updatePayload, {transaction});

        
        
        if (data.stock_reception !== undefined) {
            await stock_reception_items.setStock_reception(
              
              data.stock_reception,
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await stock_reception_items.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await stock_reception_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return stock_reception_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_reception_items = await db.stock_reception_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of stock_reception_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of stock_reception_items) {
                await record.destroy({transaction});
            }
        });


        return stock_reception_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const stock_reception_items = await db.stock_reception_items.findByPk(id, options);

        await stock_reception_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await stock_reception_items.destroy({
            transaction
        });

        return stock_reception_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const stock_reception_items = await db.stock_reception_items.findOne(
            { where },
            { transaction },
        );

        if (!stock_reception_items) {
            return stock_reception_items;
        }

        const output = stock_reception_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.stock_reception = await stock_reception_items.getStock_reception({
            transaction
        });
        
        
        output.product = await stock_reception_items.getProduct({
            transaction
        });
        
        
        output.organizations = await stock_reception_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.stock_receptions,
        as: 'stock_reception',
        
        where: filter.stock_reception ? {
          [Op.or]: [
            { id: { [Op.in]: filter.stock_reception.split('|').map(term => Utils.uuid(term)) } },
            {
              reception_number: {
                [Op.or]: filter.stock_reception.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.batch_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stock_reception_items',
                        'batch_code',
                        filter.batch_code,
                    ),
                };
            }
            

            
            

            
            if (filter.quantity_receivedRange) {
                const [start, end] = filter.quantity_receivedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_received: {
                    ...where.quantity_received,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_received: {
                    ...where.quantity_received,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_cost_htRange) {
                const [start, end] = filter.unit_cost_htRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_cost_ht: {
                    ...where.unit_cost_ht,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_cost_ht: {
                    ...where.unit_cost_ht,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expiry_dateRange) {
                const [start, end] = filter.expiry_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expiry_date: {
                    ...where.expiry_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expiry_date: {
                    ...where.expiry_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.stock_reception_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'stock_reception_items',
                        'batch_code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.stock_reception_items.findAll({
            attributes: [ 'id', 'batch_code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['batch_code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.batch_code,
        }));
    }

    
};

